=begin
#Pulp 3 API

#Fetch, Upload, Organize, and Distribute Software Packages

The version of the OpenAPI document: v3
Contact: pulp-list@redhat.com
Generated by: https://openapi-generator.tech
OpenAPI Generator version: 4.3.1

=end

require 'cgi'

module PulpcoreClient
  class ExportersPulpApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Create a pulp exporter
    # ViewSet for viewing PulpExporters.
    # @param pulp_exporter [PulpExporter] 
    # @param [Hash] opts the optional parameters
    # @return [PulpExporterResponse]
    def create(pulp_exporter, opts = {})
      data, _status_code, _headers = create_with_http_info(pulp_exporter, opts)
      data
    end

    # Create a pulp exporter
    # ViewSet for viewing PulpExporters.
    # @param pulp_exporter [PulpExporter] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(PulpExporterResponse, Integer, Hash)>] PulpExporterResponse data, response status code and response headers
    def create_with_http_info(pulp_exporter, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ExportersPulpApi.create ...'
      end
      # verify the required parameter 'pulp_exporter' is set
      if @api_client.config.client_side_validation && pulp_exporter.nil?
        fail ArgumentError, "Missing the required parameter 'pulp_exporter' when calling ExportersPulpApi.create"
      end
      # resource path
      local_var_path = '/pulp/api/v3/exporters/core/pulp/'

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(pulp_exporter) 

      # return_type
      return_type = opts[:return_type] || 'PulpExporterResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:POST, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ExportersPulpApi#create\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Delete a pulp exporter
    # Trigger an asynchronous delete task
    # @param pulp_exporter_href [String] 
    # @param [Hash] opts the optional parameters
    # @return [AsyncOperationResponse]
    def delete(pulp_exporter_href, opts = {})
      data, _status_code, _headers = delete_with_http_info(pulp_exporter_href, opts)
      data
    end

    # Delete a pulp exporter
    # Trigger an asynchronous delete task
    # @param pulp_exporter_href [String] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(AsyncOperationResponse, Integer, Hash)>] AsyncOperationResponse data, response status code and response headers
    def delete_with_http_info(pulp_exporter_href, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ExportersPulpApi.delete ...'
      end
      # verify the required parameter 'pulp_exporter_href' is set
      if @api_client.config.client_side_validation && pulp_exporter_href.nil?
        fail ArgumentError, "Missing the required parameter 'pulp_exporter_href' when calling ExportersPulpApi.delete"
      end
      # resource path
      local_var_path = '{pulp_exporter_href}'.sub('{' + 'pulp_exporter_href' + '}', CGI.escape(pulp_exporter_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'AsyncOperationResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ExportersPulpApi#delete\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # List pulp exporters
    # ViewSet for viewing PulpExporters.
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :limit Number of results to return per page.
    # @option opts [String] :name 
    # @option opts [String] :name__contains Filter results where name contains value
    # @option opts [String] :name__icontains Filter results where name contains value
    # @option opts [Array<String>] :name__in Filter results where name is in a comma-separated list of values
    # @option opts [String] :name__startswith Filter results where name starts with value
    # @option opts [Integer] :offset The initial index from which to return the results.
    # @option opts [String] :ordering Which field to use when ordering the results.
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [PaginatedPulpExporterResponseList]
    def list(opts = {})
      data, _status_code, _headers = list_with_http_info(opts)
      data
    end

    # List pulp exporters
    # ViewSet for viewing PulpExporters.
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :limit Number of results to return per page.
    # @option opts [String] :name 
    # @option opts [String] :name__contains Filter results where name contains value
    # @option opts [String] :name__icontains Filter results where name contains value
    # @option opts [Array<String>] :name__in Filter results where name is in a comma-separated list of values
    # @option opts [String] :name__startswith Filter results where name starts with value
    # @option opts [Integer] :offset The initial index from which to return the results.
    # @option opts [String] :ordering Which field to use when ordering the results.
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [Array<(PaginatedPulpExporterResponseList, Integer, Hash)>] PaginatedPulpExporterResponseList data, response status code and response headers
    def list_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ExportersPulpApi.list ...'
      end
      # resource path
      local_var_path = '/pulp/api/v3/exporters/core/pulp/'

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'limit'] = opts[:'limit'] if !opts[:'limit'].nil?
      query_params[:'name'] = opts[:'name'] if !opts[:'name'].nil?
      query_params[:'name__contains'] = opts[:'name__contains'] if !opts[:'name__contains'].nil?
      query_params[:'name__icontains'] = opts[:'name__icontains'] if !opts[:'name__icontains'].nil?
      query_params[:'name__in'] = @api_client.build_collection_param(opts[:'name__in'], :csv) if !opts[:'name__in'].nil?
      query_params[:'name__startswith'] = opts[:'name__startswith'] if !opts[:'name__startswith'].nil?
      query_params[:'offset'] = opts[:'offset'] if !opts[:'offset'].nil?
      query_params[:'ordering'] = opts[:'ordering'] if !opts[:'ordering'].nil?
      query_params[:'fields'] = opts[:'fields'] if !opts[:'fields'].nil?
      query_params[:'exclude_fields'] = opts[:'exclude_fields'] if !opts[:'exclude_fields'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'PaginatedPulpExporterResponseList' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ExportersPulpApi#list\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Update a pulp exporter
    # Trigger an asynchronous partial update task
    # @param pulp_exporter_href [String] 
    # @param patched_pulp_exporter [PatchedPulpExporter] 
    # @param [Hash] opts the optional parameters
    # @return [AsyncOperationResponse]
    def partial_update(pulp_exporter_href, patched_pulp_exporter, opts = {})
      data, _status_code, _headers = partial_update_with_http_info(pulp_exporter_href, patched_pulp_exporter, opts)
      data
    end

    # Update a pulp exporter
    # Trigger an asynchronous partial update task
    # @param pulp_exporter_href [String] 
    # @param patched_pulp_exporter [PatchedPulpExporter] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(AsyncOperationResponse, Integer, Hash)>] AsyncOperationResponse data, response status code and response headers
    def partial_update_with_http_info(pulp_exporter_href, patched_pulp_exporter, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ExportersPulpApi.partial_update ...'
      end
      # verify the required parameter 'pulp_exporter_href' is set
      if @api_client.config.client_side_validation && pulp_exporter_href.nil?
        fail ArgumentError, "Missing the required parameter 'pulp_exporter_href' when calling ExportersPulpApi.partial_update"
      end
      # verify the required parameter 'patched_pulp_exporter' is set
      if @api_client.config.client_side_validation && patched_pulp_exporter.nil?
        fail ArgumentError, "Missing the required parameter 'patched_pulp_exporter' when calling ExportersPulpApi.partial_update"
      end
      # resource path
      local_var_path = '{pulp_exporter_href}'.sub('{' + 'pulp_exporter_href' + '}', CGI.escape(pulp_exporter_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(patched_pulp_exporter) 

      # return_type
      return_type = opts[:return_type] || 'AsyncOperationResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:PATCH, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ExportersPulpApi#partial_update\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Inspect a pulp exporter
    # ViewSet for viewing PulpExporters.
    # @param pulp_exporter_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [PulpExporterResponse]
    def read(pulp_exporter_href, opts = {})
      data, _status_code, _headers = read_with_http_info(pulp_exporter_href, opts)
      data
    end

    # Inspect a pulp exporter
    # ViewSet for viewing PulpExporters.
    # @param pulp_exporter_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [Array<(PulpExporterResponse, Integer, Hash)>] PulpExporterResponse data, response status code and response headers
    def read_with_http_info(pulp_exporter_href, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ExportersPulpApi.read ...'
      end
      # verify the required parameter 'pulp_exporter_href' is set
      if @api_client.config.client_side_validation && pulp_exporter_href.nil?
        fail ArgumentError, "Missing the required parameter 'pulp_exporter_href' when calling ExportersPulpApi.read"
      end
      # resource path
      local_var_path = '{pulp_exporter_href}'.sub('{' + 'pulp_exporter_href' + '}', CGI.escape(pulp_exporter_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'fields'] = opts[:'fields'] if !opts[:'fields'].nil?
      query_params[:'exclude_fields'] = opts[:'exclude_fields'] if !opts[:'exclude_fields'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'PulpExporterResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ExportersPulpApi#read\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Update a pulp exporter
    # Trigger an asynchronous update task
    # @param pulp_exporter_href [String] 
    # @param pulp_exporter [PulpExporter] 
    # @param [Hash] opts the optional parameters
    # @return [AsyncOperationResponse]
    def update(pulp_exporter_href, pulp_exporter, opts = {})
      data, _status_code, _headers = update_with_http_info(pulp_exporter_href, pulp_exporter, opts)
      data
    end

    # Update a pulp exporter
    # Trigger an asynchronous update task
    # @param pulp_exporter_href [String] 
    # @param pulp_exporter [PulpExporter] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(AsyncOperationResponse, Integer, Hash)>] AsyncOperationResponse data, response status code and response headers
    def update_with_http_info(pulp_exporter_href, pulp_exporter, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ExportersPulpApi.update ...'
      end
      # verify the required parameter 'pulp_exporter_href' is set
      if @api_client.config.client_side_validation && pulp_exporter_href.nil?
        fail ArgumentError, "Missing the required parameter 'pulp_exporter_href' when calling ExportersPulpApi.update"
      end
      # verify the required parameter 'pulp_exporter' is set
      if @api_client.config.client_side_validation && pulp_exporter.nil?
        fail ArgumentError, "Missing the required parameter 'pulp_exporter' when calling ExportersPulpApi.update"
      end
      # resource path
      local_var_path = '{pulp_exporter_href}'.sub('{' + 'pulp_exporter_href' + '}', CGI.escape(pulp_exporter_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(pulp_exporter) 

      # return_type
      return_type = opts[:return_type] || 'AsyncOperationResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:PUT, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ExportersPulpApi#update\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
