=begin
#Pulp 3 API

#Fetch, Upload, Organize, and Distribute Software Packages

The version of the OpenAPI document: v3
Contact: pulp-list@redhat.com
Generated by: https://openapi-generator.tech
OpenAPI Generator version: 4.3.1

=end

require 'cgi'

module PulpcoreClient
  class OrphansCleanupApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Trigger an asynchronous orphan cleanup operation.
    # @param orphans_cleanup [OrphansCleanup] 
    # @param [Hash] opts the optional parameters
    # @return [AsyncOperationResponse]
    def cleanup(orphans_cleanup, opts = {})
      data, _status_code, _headers = cleanup_with_http_info(orphans_cleanup, opts)
      data
    end

    # Trigger an asynchronous orphan cleanup operation.
    # @param orphans_cleanup [OrphansCleanup] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(AsyncOperationResponse, Integer, Hash)>] AsyncOperationResponse data, response status code and response headers
    def cleanup_with_http_info(orphans_cleanup, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: OrphansCleanupApi.cleanup ...'
      end
      # verify the required parameter 'orphans_cleanup' is set
      if @api_client.config.client_side_validation && orphans_cleanup.nil?
        fail ArgumentError, "Missing the required parameter 'orphans_cleanup' when calling OrphansCleanupApi.cleanup"
      end
      # resource path
      local_var_path = '/pulp/api/v3/orphans/cleanup/'

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(orphans_cleanup) 

      # return_type
      return_type = opts[:return_type] || 'AsyncOperationResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:POST, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: OrphansCleanupApi#cleanup\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
